
//          LISA V3 , on STM32F303RET , Nucleo64
/**********************************************************************************************
31.01.2020  6 LCD test auf nucleo64 mit STM32F303RET...uff. ST7793 , 400x240 pix, 32 MHz !
02.02.2020  4 touchscreen korr. , ok. 40 MHz , 46 KB.
03.02.      3 nana...27J. alte FFT von LISA...test: ok, ca. 150 dB Dynamik (float)
07.02.      3 wie HAL aufrufen..ok. AD input A5 .
08. ..13.  12 Drama: wie HAL aufrufen...aber richtig!!! im stm32duino forum angemeldet + gefragt..
14.02.     12 info von fpiSTM ...howto. ok...buid_opt.h is der Trick ! + ADC1/2/3 init ! ok.

// Run the TouchScreen_Calibr_native sketch for calibration of your shield for testing !
//**********************************************************************************************

 ADC3IN5 = PB13 -> audio in 
 + ADC3 ADC_SAMPLETIME_19CYCLES_5; +  RCC_ADC34PLLCLK_DIV1; --> ca. 800 ks /sec. (mit HAL call)

  
//**********************************************************************************************/

#include <MCUFRIEND_kbv.h>

#include <TouchScren.h>                               // the mod. touchscreen , HAL analog in

#define BSP_LED_Init(X)  pinMode(X,OUTPUT)
#define BSP_LED_On(X)    digitalWrite(X,LOW)
#define BSP_LED_Off(X)   digitalWrite(X,HIGH)
#define LED1 16
#define LED3 13
#define SERIALX Serial
#define MINPRESSURE 100
#define MAXPRESSURE 1000
#define NN 512
                                                      // Assign human-readable names to some common 16-bit color values:
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF


char *name = "F303 .DSO ";                            //edit name of shield
const int YM=7,XM=A1,YP=A2,XP=6;                      //ID=0x7793 , controller is ST7793
const int TS_LEFT=92,TS_RT=918,TS_TOP=62,TS_BOT=939;
MCUFRIEND_kbv tft;                                    // hard-wired for UNO shields anyway.
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);
TSPoint tp;
ADC_HandleTypeDef    Adc1Handle, Adc2Handle, Adc3Handle;

int16_t BOXSIZE;
int16_t PENRADIUS = 1, progstate=1;
uint16_t ID, oldcolor, currentcolor;
uint8_t Orientation = 1;                              //0 PORTRAIT, 1 Landscape
float   ar[2*NN+14],ai[NN+4],b,e,k,wr,wi,tr,ti,wlen, wanf;
int16_t N,n,n1,n2,a,c,d,f,g,h,i,j,l,ist,m,p,q,r,s,t,u,w,z,key,sam,kor,ref;
int16_t ii[NN+4];


//**********************************************************************************************/

static void ADC1_Config(void)
{
  ADC_ChannelConfTypeDef   sConfig;
  ADC_AnalogWDGConfTypeDef AnalogWDGConfig;

  /* Configuration of ADCx init structure: ADC parameters and regular group */
  Adc1Handle.Instance = ADC1;

  Adc1Handle.Init.DataAlign             = ADC_DATAALIGN_RIGHT;
  Adc1Handle.Init.ScanConvMode          = ADC_SCAN_DISABLE;              /* Sequencer disabled (ADC conversion on only 1 channel: channel set on rank 1) */
#if defined ADC_TRIGGER_FROM_TIMER
  Adc1Handle.Init.ContinuousConvMode    = DISABLE;                       /* Continuous mode disabled to have only 1 conversion at each conversion trig */
#else
  Adc1Handle.Init.ContinuousConvMode    = ENABLE;                        /* Continuous mode to have maximum conversion speed (no delay between conversions) */
#endif
  Adc1Handle.Init.NbrOfConversion       = 1;                             /* Parameter discarded because sequencer is disabled */
  Adc1Handle.Init.DiscontinuousConvMode = DISABLE;                       /* Parameter discarded because sequencer is disabled */
  Adc1Handle.Init.NbrOfDiscConversion   = 1;                             /* Parameter discarded because sequencer is disabled */
#if defined ADC_TRIGGER_FROM_TIMER
  Adc1Handle.Init.ExternalTrigConv      = ADC_EXTERNALTRIGCONV_Tx_TRGO;  /* Trig of conversion start done by external event */
#else
  Adc1Handle.Init.ExternalTrigConv      = ADC_SOFTWARE_START;            /* Software start to trig the 1st conversion manually, without external event */
#endif

  if (HAL_ADC_Init(&Adc1Handle) != HAL_OK)
  {
    /* ADC initialization error */
    Error_Handler();
  }

  /* Configuration of channel on ADCx regular group on sequencer rank 1 */
  /* Note: Considering IT occurring after each ADC conversion if ADC          */
  /*       conversion is out of the analog watchdog window selected (ADC IT   */
  /*       enabled), select sampling time and ADC clock with sufficient       */
  /*       duration to not create an overhead situation in IRQHandler.        */
  sConfig.Channel      = ADC_CHANNEL_2;
  sConfig.Rank         = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_19CYCLES_5;

  if (HAL_ADC_ConfigChannel(&Adc1Handle, &sConfig) != HAL_OK)
  {
    /* Channel Configuration Error */
    Error_Handler();
  }

  /* Set analog watchdog thresholds in order to be between steps of DAC       */
  /* voltage.                                                                 */
  /*  - High threshold: between DAC steps 1/2 and 3/4 of full range:          */
  /*                    5/8 of full range (4095 <=> Vdda=3.3V): 2559<=> 2.06V */
  /*  - Low threshold:  between DAC steps 0 and 1/4 of full range:            */
  /*                    1/8 of full range (4095 <=> Vdda=3.3V): 512 <=> 0.41V */

  /* Analog watchdog 1 configuration */
//  AnalogWDGConfig.WatchdogMode = ADC_ANALOGWATCHDOG_ALL_REG;
//  AnalogWDGConfig.Channel = ADC_CHANNEL_4;
//  AnalogWDGConfig.ITMode = ENABLE;
//  AnalogWDGConfig.HighThreshold = (RANGE_12BITS * 5 / 8);
//  AnalogWDGConfig.LowThreshold = (RANGE_12BITS * 1 / 8);
//  if (HAL_ADC_AnalogWDGConfig(&AdcHandle, &AnalogWDGConfig) != HAL_OK)
//  {
    /* Channel Configuration Error */
 //   Error_Handler();
//  }
}
//**********************************************************************************************/

static void ADC2_Config(void)
{
  ADC_ChannelConfTypeDef   sConfig;
  ADC_AnalogWDGConfTypeDef AnalogWDGConfig;

  /* Configuration of ADCx init structure: ADC parameters and regular group */
  Adc2Handle.Instance = ADC2;

  Adc2Handle.Init.DataAlign             = ADC_DATAALIGN_RIGHT;
  Adc2Handle.Init.ScanConvMode          = ADC_SCAN_DISABLE;              /* Sequencer disabled (ADC conversion on only 1 channel: channel set on rank 1) */
#if defined ADC_TRIGGER_FROM_TIMER
  Adc2Handle.Init.ContinuousConvMode    = DISABLE;                       /* Continuous mode disabled to have only 1 conversion at each conversion trig */
#else
  Adc2Handle.Init.ContinuousConvMode    = ENABLE;                        /* Continuous mode to have maximum conversion speed (no delay between conversions) */
#endif
  Adc2Handle.Init.NbrOfConversion       = 1;                             /* Parameter discarded because sequencer is disabled */
  Adc2Handle.Init.DiscontinuousConvMode = DISABLE;                       /* Parameter discarded because sequencer is disabled */
  Adc2Handle.Init.NbrOfDiscConversion   = 1;                             /* Parameter discarded because sequencer is disabled */
#if defined ADC_TRIGGER_FROM_TIMER
  Adc2Handle.Init.ExternalTrigConv      = ADC_EXTERNALTRIGCONV_Tx_TRGO;  /* Trig of conversion start done by external event */
#else
  Adc2Handle.Init.ExternalTrigConv      = ADC_SOFTWARE_START;            /* Software start to trig the 1st conversion manually, without external event */
#endif

  if (HAL_ADC_Init(&Adc2Handle) != HAL_OK)
  {
    /* ADC initialization error */
    Error_Handler();
  }

  /* Configuration of channel on ADCx regular group on sequencer rank 1 */
  /* Note: Considering IT occurring after each ADC conversion if ADC          */
  /*       conversion is out of the analog watchdog window selected (ADC IT   */
  /*       enabled), select sampling time and ADC clock with sufficient       */
  /*       duration to not create an overhead situation in IRQHandler.        */
  sConfig.Channel      = ADC_CHANNEL_1;
  sConfig.Rank         = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_19CYCLES_5;

  if (HAL_ADC_ConfigChannel(&Adc2Handle, &sConfig) != HAL_OK)
  {
    /* Channel Configuration Error */
    Error_Handler();
  }
}
//***************************************************************************/
static void ADC3_Config(void)
{
  ADC_ChannelConfTypeDef   sConfig;
  ADC_AnalogWDGConfTypeDef AnalogWDGConfig;

  /* Configuration of ADCx init structure: ADC parameters and regular group */
  Adc3Handle.Instance = ADC3;

  Adc3Handle.Init.DataAlign             = ADC_DATAALIGN_RIGHT;
  Adc3Handle.Init.ScanConvMode          = ADC_SCAN_DISABLE;              /* Sequencer disabled (ADC conversion on only 1 channel: channel set on rank 1) */
#if defined ADC_TRIGGER_FROM_TIMER
  Adc3Handle.Init.ContinuousConvMode    = DISABLE;                       /* Continuous mode disabled to have only 1 conversion at each conversion trig */
#else
  Adc3Handle.Init.ContinuousConvMode    = ENABLE;                        /* Continuous mode to have maximum conversion speed (no delay between conversions) */
#endif
  Adc3Handle.Init.NbrOfConversion       = 1;                             /* Parameter discarded because sequencer is disabled */
  Adc3Handle.Init.DiscontinuousConvMode = DISABLE;                       /* Parameter discarded because sequencer is disabled */
  Adc3Handle.Init.NbrOfDiscConversion   = 1;                             /* Parameter discarded because sequencer is disabled */
#if defined ADC_TRIGGER_FROM_TIMER
  Adc3Handle.Init.ExternalTrigConv      = ADC_EXTERNALTRIGCONV_Tx_TRGO;  /* Trig of conversion start done by external event */
#else
  Adc3Handle.Init.ExternalTrigConv      = ADC_SOFTWARE_START;            /* Software start to trig the 1st conversion manually, without external event */
#endif

  if (HAL_ADC_Init(&Adc3Handle) != HAL_OK)
  {
    /* ADC initialization error */
    Error_Handler();
  }

  /* Configuration of channel on ADCx regular group on sequencer rank 1 */
  /* Note: Considering IT occurring after each ADC conversion if ADC          */
  /*       conversion is out of the analog watchdog window selected (ADC IT   */
  /*       enabled), select sampling time and ADC clock with sufficient       */
  /*       duration to not create an overhead situation in IRQHandler.        */
  sConfig.Channel      = ADC_CHANNEL_5;
  sConfig.Rank         = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_19CYCLES_5;

  if (HAL_ADC_ConfigChannel(&Adc3Handle, &sConfig) != HAL_OK)
  {
    /* Channel Configuration Error */
    Error_Handler();
  }
}
/***************************************************************************/
extern "C" void HAL_ADC_MspInit(ADC_HandleTypeDef *hadc)
{
  GPIO_InitTypeDef          GPIO_InitStruct;
  static DMA_HandleTypeDef  DmaHandle;
  RCC_PeriphCLKInitTypeDef  PeriphClkInit;

  /*##-1- Enable peripherals and GPIO Clocks #################################*/
  /* Enable clock of GPIO associated to the peripheral channels */
  //  __HAL_RCC_GPIOA_CLK_ENABLE();

  /* Enable clock of ADCx peripheral */
  __HAL_RCC_ADC12_CLK_ENABLE();
  __HAL_RCC_ADC34_CLK_ENABLE();

  /* Configure ADCx clock prescaler */
  /* Caution: On STM32F1, ADC clock frequency max is 14MHz (refer to device   */
  /*          datasheet).                                                     */
  /*          Therefore, ADC clock prescaler must be configured in function   */
  /*          of ADC clock source frequency to remain below this maximum      */
  /*          frequency.                                                      */
  
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USART2|RCC_PERIPHCLK_ADC12
                              |RCC_PERIPHCLK_ADC34;
  PeriphClkInit.Adc12ClockSelection = RCC_ADC12PLLCLK_DIV6;
  PeriphClkInit.Adc34ClockSelection = RCC_ADC34PLLCLK_DIV1;
  HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit);

  /* Enable clock of DMA associated to the peripheral */
//  __HAL_RCC_DMA1_CLK_ENABLE();

  /*##-2- Configure peripheral GPIO ##########################################*/
  /* Configure GPIO pin of the selected ADC channel */
//  GPIO_InitStruct.Pin = ADC_CHANNEL_4;
//  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
//  GPIO_InitStruct.Pull = GPIO_PIN_4;
//  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

}
//**********************************************************************************************/


extern "C" void HAL_ADC_ErrorCallback(ADC_HandleTypeDef * )
{
  /* In case of ADC error, call main error handler */
  Error_Handler();
}

void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

   SERIALX.print("Assert failed! ");
   SERIALX.print("File '");
   SERIALX.print((char*)file);
   SERIALX.print("', Line ");
   SERIALX.println(line);
  
  /* Rapid blink */
   while(1) { 
     BSP_LED_On(LED3);
     delay (100);
     BSP_LED_Off(LED3);
     delay (100);
    } 
}
/***************************************************************************/
void  draw_sin()                                                        // generate test signal : sinus.mix
{
int16_t j,x1, y1=120, x2, y2;
float i;
//    moveto(0, 300); /* Move to beginning of cord  */
  for( j=0 ; j<NN+1 ; j++ )
  { /* For each remaining intersect */
    i=sin((float)j*50*PI/NN)+0.5*sin(j*6*PI/NN)+0.0001*sin((float)j*80*PI/NN)+0.00001*sin((float)j*200*PI/NN) +0.000001*sin((float)j*400*PI/NN);
/*    lineto(j, 350+i*50);  Draw the cord   */
    y2 = 120 - i*50;
    tft.drawLine(x1, y1, j, y2, RED);

    x1=j; y1 = y2;

    ar[j]=i*3000 /* +random(3) */ ;ai[j]=0;

  }
}
/***************************************************************************/

void  draw_A5()                                                        // get signal : adc.input
{
int16_t j,ji, x1, y1=120, x2, y2, adval, loops;
float in;

   pinMode(PB13, INPUT_ANALOG);

        
  for( j=0 ; j<NN+1 ; j++ )
  { 

/*loops=0;
ADC1->CR = 0x10000005;                                                 // adc start direct access
while(  (ADC1->ISR & 0x4 ) )                                           // ADC_CR_ADSTART
{ loops++; if(loops == 10) break;   }                                  // adc ready ?

 ii[j] = ADC1->DR ;
*/

    adval = 0;   
  
    for( ji=0 ; ji<16 ; ji++ )                                        // sum 16 -> 16b data at 60ks = Fmax 30kHz
    {
        HAL_ADC_Start(&Adc3Handle);
        while ((HAL_ADC_GetState(&Adc3Handle), HAL_ADC_STATE_READY) == 0);
        adval = adval + HAL_ADC_GetValue(&Adc3Handle);
    }     
    ii[j] = adval ;                                                   // to array
  }
    
    
  for( j=0 ; j<NN+1 ; j++ )                                           // show data line
  {

    in= (float)ii[j] - 32000;
    y2 = 120 - in/400;  // war 20
    tft.drawLine(x1, y1, j, y2, RED);
    x1=j; y1 = y2;
    ar[j]= ii[j]; /* +random(3) */ ;ai[j]=0;
  }
}
/***************************************************************************/
void show_data()
{
  int16_t  j,YOF,x1, y1=230,altj, y2;
  float i,alti, maxdb, rel1, rel2, rel3, ymag=10;
    //  maxdb=rel1=rel2=rel3=-200;
    //  alti=-100;
    //  YOF = ymag*log10((double)32768*32768);
    //    moveto(XOF, YOF); /* Move to beginning of cord  */
  for( j=1 ; j<NN/2 ; j++ ){ /* For each remaining intersect */
    i=fabs(ar[j]*ar[j]);
    i=i+fabs(ai[j]*ai[j]);
    if(i!=0)
    i=ymag*log10(i);
      else
    i=-20;
    y2 = 180-i;
    tft.drawLine(x1, y1, j,y2 ,BLUE );
      x1=j; y1 = y2;
  }
}
/***************************************************************************/
void birev()                          // FFT bitreversal (from Fortran book ! ca. 1985 !
{
  #define N1 NN-1
  int16_t mr,m,n,l;
  float tr;
  div_t erg;

   mr=0;

  for(m=1;m<N1;m++)
  {
   l=NN;
   lab1:
   l=l/2;
   if((mr+l)>N1)
      goto lab1;
   erg=div(mr,l);
   mr=erg.rem+l;
   if(mr<=m)
      goto lab2;
   tr=ar[m];
   ar[m]=ar[mr];
   ar[mr]=tr;
   lab2:
   ;
  }
}
//**************************************************************************
void fft()                    // FFT standard, inplace,  float, no optim. (from Fortran book ! ca. 1985 !
{   l=1;
  do{
    ist=2*l;
    for(m=0;m<l;m++)
    {
      e=PI*(float)(m)/l;
      wi=sin(e);
      wr=cos(e);

      for(i=m;i<NN;i+=ist)
      {
        j=i+l;
        tr=wr*ar[j]-wi*ai[j];
        ti=wr*ai[j]+wi*ar[j];
        ar[j]=ar[i]-tr;
        ai[j]=ai[i]-ti;
        ar[i]=ar[i]+tr;
        ai[i]=ai[i]+ti;
      }
    }
    l=ist;
  }while(l<NN);

}

//***************************************************************************
void show_Serial(void)
{
    Serial.println(F("Most Touch Screens use pins 6, 7, A1, A2"));
    Serial.println(F("But they can be in ANY order"));
    Serial.println(F("e.g. right to left or bottom to top"));
    Serial.println(F("or wrong direction"));
    Serial.println(F("Edit name and calibration statements\n"));
    Serial.println(name);
    Serial.print(F("ID=0x"));
    Serial.println(ID, HEX);
    Serial.println("Screen is " + String(tft.width()) + "x" + String(tft.height()));
    Serial.println("Calibration is: ");
    Serial.println("LEFT = " + String(TS_LEFT) + " RT  = " + String(TS_RT));
    Serial.println("TOP  = " + String(TS_TOP)  + " BOT = " + String(TS_BOT));
    Serial.println("Wiring is always PORTRAIT");
    Serial.println("YP=" + String(YP)  + " XM=" + String(XM));
    Serial.println("YM=" + String(YM)  + " XP=" + String(XP));
}

void show_tft(void)
{
    tft.setCursor(0, 0);
    tft.setTextSize(1);
    tft.print(F("ID=0x"));
    tft.println(ID, HEX);
    tft.println("Screen is " + String(tft.width()) + "x" + String(tft.height()));
    tft.println("");
    tft.setTextSize(2);
    tft.println(name);
    tft.setTextSize(1);
    tft.println("PORTRAIT Values:");
    tft.println("LEFT = " + String(TS_LEFT) + " RT  = " + String(TS_RT));
    tft.println("TOP  = " + String(TS_TOP)  + " BOT = " + String(TS_BOT));
    tft.println("\nWiring is: ");
    tft.println("YP=" + String(YP)  + " XM=" + String(XM));
    tft.println("YM=" + String(YM)  + " XP=" + String(XP));
    tft.setTextSize(2);
    tft.setTextColor(RED);
    tft.setCursor((tft.width() - 48) / 2, (tft.height() * 2) / 4);
    tft.print("EXIT");
    tft.setTextColor(YELLOW, BLACK);
    tft.setCursor(0, (tft.height() * 6) / 8);
    tft.print("Touch screen for loc");
    while (1) {
        tp = ts.getPoint();
        pinMode(XM, OUTPUT);
        pinMode(YP, OUTPUT);
        if (tp.z < MINPRESSURE || tp.z > MAXPRESSURE) continue;
        if (tp.x > 450 && tp.x < 570  && tp.y > 450 && tp.y < 570) break;
        tft.setCursor(0, (tft.height() * 3) / 4);
        tft.print("tp.x=" + String(tp.x) + " tp.y=" + String(tp.y) + "   ");
    }
}

//**********************************************************************************************
void setup(void)
{
    uint16_t tmp;

    pinMode(PA1, INPUT_ANALOG);
    pinMode(PA2, INPUT_ANALOG);
    pinMode(PB13, INPUT_ANALOG);


    pinMode(LED_BUILTIN, OUTPUT);
    digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)
    tft.reset();
    ID = tft.readID();
    tft.begin(ID);
    Serial.begin(9600);
    show_Serial();
    tft.setRotation(Orientation);
    tft.fillScreen(BLACK);
    BOXSIZE = tft.width() / 6;
    tft.fillScreen(BLACK);
    tft.fillRect(0, 0, BOXSIZE, BOXSIZE, RED);
    tft.fillRect(BOXSIZE, 0, BOXSIZE, BOXSIZE, YELLOW);
    tft.fillRect(BOXSIZE * 2, 0, BOXSIZE, BOXSIZE, GREEN);
    tft.fillRect(BOXSIZE * 3, 0, BOXSIZE, BOXSIZE, CYAN);
    tft.fillRect(BOXSIZE * 4, 0, BOXSIZE, BOXSIZE, BLUE);
    tft.fillRect(BOXSIZE * 5, 0, BOXSIZE, BOXSIZE, MAGENTA);
    tft.drawRect(0, 0, BOXSIZE, BOXSIZE, WHITE);
    currentcolor = RED;
    tft.setCursor(20, 150);
    tft.setTextSize(1);
    tft.setTextColor(GREEN);

    digitalWrite(LED_BUILTIN, LOW);   // turn the LED on (HIGH is the voltage level)
    delay(500);

    ADC1_Config();//
    ADC2_Config();//
    ADC3_Config();//
    /* Run the ADC calibration */
    if (HAL_ADCEx_Calibration_Start(&Adc1Handle, ADC_SINGLE_ENDED) != HAL_OK);// {
    if (HAL_ADCEx_Calibration_Start(&Adc2Handle, ADC_SINGLE_ENDED) != HAL_OK);
    if (HAL_ADCEx_Calibration_Start(&Adc3Handle, ADC_SINGLE_ENDED) != HAL_OK);
    /* Calibration Error */
//    Error_Handler();
 // }
    digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)
    tft.print("F_CPU:");
    tft.print(0.000001 * F_CPU);        // is 72 MHZ standard, max. 
    delay(500);
}
//*********************************************************************************************
void loop()
{

    uint16_t xpos, ypos;  //screen coordinates
//goto test;

    tp = ts.getPoint();   //tp.x, tp.y are ADC values

 
// Serial.println("YM=" + String(tp.y)+ " XP=" + String(tp.x)  + " ZP=" + String(tp.z));
    // if sharing pins, you'll need to fix the directions of the touchscreen pins
    pinMode(XM, OUTPUT);
    pinMode(YP, OUTPUT);
    // we have some minimum pressure we consider 'valid'
    // pressure of 0 means no pressing!
    if (tp.z > MINPRESSURE && tp.z < MAXPRESSURE)                       // nur bei touch pressed -> switch menu
    {
        // most mcufriend have touch (with icons) that extends below the TFT
        // screens without icons need to reserve a space for "erase"
        // scale the ADC values from ts.getPoint() to screen values e.g. 0-239
        //
        // Calibration is true for PORTRAIT. tp.y is always long dimension 
        // map to your current pixel orientation
        switch (Orientation) {
            case 0:
                xpos = map(tp.x, TS_LEFT, TS_RT, 0, tft.width());
                ypos = map(tp.y, TS_TOP, TS_BOT, 0, tft.height());
                break;
            case 1:
                xpos = map(tp.y, TS_TOP, TS_BOT, 0, tft.width());
                ypos = map(tp.x, TS_RT, TS_LEFT, 0, tft.height());
                break;
            case 2:
                xpos = map(tp.x, TS_RT, TS_LEFT, 0, tft.width());
                ypos = map(tp.y, TS_BOT, TS_TOP, 0, tft.height());
                break;
            case 3:
                xpos = map(tp.y, TS_BOT, TS_TOP, 0, tft.width());
                ypos = map(tp.x, TS_LEFT, TS_RT, 0, tft.height());
                break;
        }
  test:      
 //  progstate = 4;  // exit test  
   switch(progstate)                                                  // switch menu
    {
      case 1:
        // are we in top color box area ?
        if (ypos < BOXSIZE) {               //draw white border on selected color box
            oldcolor = currentcolor;

            if (xpos < BOXSIZE) {
                currentcolor = RED;
                tft.drawRect(0, 0, BOXSIZE, BOXSIZE, WHITE);
            } else if (xpos < BOXSIZE * 2) {
                currentcolor = YELLOW;
                tft.drawRect(BOXSIZE, 0, BOXSIZE, BOXSIZE, WHITE);
            } else if (xpos < BOXSIZE * 3) {
                currentcolor = GREEN;
                tft.drawRect(BOXSIZE * 2, 0, BOXSIZE, BOXSIZE, WHITE);
            } else if (xpos < BOXSIZE * 4) {
                currentcolor = CYAN;
                tft.drawRect(BOXSIZE * 3, 0, BOXSIZE, BOXSIZE, WHITE);
            } else if (xpos < BOXSIZE * 5) {
                currentcolor = BLUE;
                tft.drawRect(BOXSIZE * 4, 0, BOXSIZE, BOXSIZE, WHITE);
            } else if (xpos < BOXSIZE * 6) {
                currentcolor = MAGENTA;progstate = 3;  // exit test
                tft.drawRect(BOXSIZE * 5, 0, BOXSIZE, BOXSIZE, WHITE);
            }

            if (oldcolor != currentcolor) { //rub out the previous white border
                if (oldcolor == RED) tft.fillRect(0, 0, BOXSIZE, BOXSIZE, RED);
                if (oldcolor == YELLOW) tft.fillRect(BOXSIZE, 0, BOXSIZE, BOXSIZE, YELLOW);
                if (oldcolor == GREEN) tft.fillRect(BOXSIZE * 2, 0, BOXSIZE, BOXSIZE, GREEN);
                if (oldcolor == CYAN) tft.fillRect(BOXSIZE * 3, 0, BOXSIZE, BOXSIZE, CYAN);
                if (oldcolor == BLUE) tft.fillRect(BOXSIZE * 4, 0, BOXSIZE, BOXSIZE, BLUE);
                if (oldcolor == MAGENTA) tft.fillRect(BOXSIZE * 5, 0, BOXSIZE, BOXSIZE, MAGENTA);
            }
        }
        // are we in drawing area ?
        if (((ypos - PENRADIUS) > BOXSIZE) && ((ypos + PENRADIUS) < tft.height())) {
            tft.fillCircle(xpos, ypos, PENRADIUS, currentcolor);
        }
        // are we in erase area ?
        // Plain Touch panels use bottom 10 pixels e.g. > h - 10
        // Touch panels with icon area e.g. > h - 0
        if (ypos > tft.height() - 10) {
            // press the bottom of the screen to erase
            tft.fillRect(0, BOXSIZE, tft.width(), tft.height() - BOXSIZE, BLACK);
        }
  
      break;
//***************************************************************************************************
      case 3 :
    
        tft.fillScreen(BLACK);
        progstate = 4;  // exit test
        tft.drawRect(20, 2, 380, 220, YELLOW);

      break;

      case 4 :
        digitalWrite(LED_BUILTIN, LOW);   // turn the LED on (HIGH is the voltage level)
        tft.fillScreen(BLACK);
    //   draw_sin();   // test FFT with sinus inputs
        draw_A5();
        birev();
        fft();
 
        progstate = 4;  // exit test
        tft.drawRect(20, 2, 380, 220, YELLOW);
        show_data();
//Serial.println("YM=" + String(tp.y)+ " XP=" + String(tp.x)  + " ZP=" + String(tp.z) + " A5="+ String(z1)); // touch debug test
        digitalWrite(LED_BUILTIN, HIGH);   // turn the LED on (HIGH is the voltage level)
      break;
    
    }

 }
} //********************************************* end ************************************************
